 /*
  * Khoros: $Id: vm180.h,v 1.1 1991/05/10 15:48:29 khoros Exp $
  */

 /*
  * $Log: vm180.h,v $
 * Revision 1.1  1991/05/10  15:48:29  khoros
 * Initial revision
 *
  */ 

/*
 *----------------------------------------------------------------------
 *
 * Copyright 1991, University of New Mexico.  All rights reserved.
 * Permission to copy and modify this software and its documen-
 * tation only for internal use in your organization is hereby
 * granted, provided that this notice is retained thereon and
 * on all copies.  UNM makes no representations as too the sui-
 * tability and operability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 * 
 * UNM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FIT-
 * NESS.  IN NO EVENT SHALL UNM BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY OTHER DAMAGES WHAT-
 * SOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PER-
 * FORMANCE OF THIS SOFTWARE.
 * 
 * No other rights, including for example, the right to redis-
 * tribute this software and its documentation or the right to
 * prepare derivative works, are granted unless specifically
 * provided in a separate license agreement.
 *---------------------------------------------------------------------
 */

#include "unmcopyright.h"        /* Copyright 1991 by UNM */


/*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 >>>>
 >>>>         File Name: vm180.h
 >>>>            Author: Pascal ADAM
 >>>> Date Last Updated: Tue Mar  5 22:30:15 1991
 >>>> 
 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/

#ifndef _vm180_h_
#define _vm180_h_

#include "vinclude.h"


/* -include_includes */
/* -include_includes_end */

char	**av,		/* argv and argc used by gparams */
	*program,	/* a pointer to the program name argv[0] */
	*calloc();
int	ac;

/****************************************************************
*
*                    vm180 Argument Structure
*
****************************************************************/

typedef struct _vm180  {

/*
 *  input image (Required infile)
 */
char	*i_file;	/* input image FILENAME */
int	 i_flag;	/* input image FLAG */

/*
 *  output image (Required outfile)
 */
char	*o_file;	/* output image FILENAME */
int	 o_flag;	/* output image FLAG */

}  vm180_struct;

vm180_struct *vm180;

/* -include_additions */
/* -include_additions_end */

/* -include_macros */
#define READINPUT(kernel) \
kernel = readimage(vm180->i_file); \
if (kernel == NULL) { \
   (void) fprintf(stderr, "vm180: Can not read input image 1\n"); \
   exit(1);  /* Quit if bad image */ \
}
#define CHECKINPUT(program, kernel) \
    propertype(program,kernel,VFF_TYP_1_BYTE,TRUE); \
    proper_num_images(program,kernel,1,TRUE); \
    proper_num_bands(program,kernel,1,TRUE); \
    proper_map_enable(program,kernel,VFF_MAP_OPTIONAL,TRUE);

/* -include_macros_end */

#endif
