 /*
  * Khoros: $Id: PlotP.h,v 1.1 1991/05/10 15:59:03 khoros Exp $
  */

 /*
  * $Log: PlotP.h,v $
 * Revision 1.1  1991/05/10  15:59:03  khoros
 * Initial revision
 *
  */ 

/*
 *----------------------------------------------------------------------
 *
 *            Copyright 1990 University of New Mexico
 *  
 *  Permission to use, copy, modify, distribute, and sell this
 *  software and its documentation for any purpose is hereby
 *  granted without fee, provided that the above copyright
 *  notice appear in all copies and that both that copyright
 *  notice and this permission notice appear in supporting docu-
 *  mentation, and that the name of UNM not be used in advertis-
 *  ing or publicity pertaining to distribution of the software
 *  without specific, written prior permission.  UNM makes no
 *  representations about the suitability of this software for
 *  any purpose.  It is provided "as is" without express or
 *  implied warranty.
 *  
 *  UNM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 *  INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FIT-
 *  NESS, IN NO EVENT SHALL UNM BE LIABLE FOR ANY SPECIAL,
 *  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
 *  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 *  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 *  ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE
 *  OF THIS SOFTWARE.
 *  
 *----------------------------------------------------------------------
 */

#include "unmcopyright.h"	 /* Copyright 1990 by UNM */

#ifndef _PlotP_h_
#define _PlotP_h_

#include "Plot.h"

typedef struct _PlotClassPart
{
   XtPointer  extension;
} PlotClassPart;


typedef struct _PlotClassRec
{
   CoreClassPart      core_class;
   CompositeClassPart composite_class;
   PlotClassPart      plot_class;
} PlotClassRec;

extern  PlotClassRec plotClassRec;


typedef struct
{
  int	  id;
  char    *title;
  Cursor  cursor;
  int	  width, height;
  float	  alpha, theta, view_distance, eye_distance, hfactor;
  Boolean active, proportional;

  XColor  fg, bg;
  Visual  *visual;
  Pixel   foreground;
  Coord   wcmin, wcmax;

  XtCallbackList  callbacks;

} PlotPart;


typedef struct _PlotRec
{
   CorePart	 core;
   CompositePart composite;
   PlotPart      plot;
} PlotRec;

#endif
/* Do not add after this line */
