 /*
  * Khoros: $Id: form_init.c,v 1.2 1992/03/20 22:51:07 dkhoros Exp $
  */

#if !defined(lint) && !defined(SABER)
static char rcsid[] = "Khoros: $Id: form_init.c,v 1.2 1992/03/20 22:51:07 dkhoros Exp $";
#endif

 /*
  * $Log: form_init.c,v $
 * Revision 1.2  1992/03/20  22:51:07  dkhoros
 * VirtualPatch5
 *
  */

/*
 *---------------------------------------------------------------------
 *            Copyright 1990 University of New Mexico
 * 
 * Permission to copy and modify this software and its documen- 
 * tation only for internal use in your organization is hereby 
 * granted, provided that this notice is retained thereon and 
 * on all copies.  UNM makes no representations as too the sui- 
 * tability and operability of this software for any purpose. 
 * It is provided 'as is' without express or implied warranty. 
 *  
 * UNM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, 
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FIT- 
 * NESS.  IN NO EVENT SHALL UNM BE LIABLE FOR ANY SPECIAL, 
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY OTHER DAMAGES WHAT- 
 * SOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER 
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS 
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PER- 
 * FORMANCE OF THIS SOFTWARE. 
 *  
 * No other rights, including for example, the right to redis- 
 * tribute this software and its documentation or the right to 
 * prepare derivative works, are granted unless specifically 
 * provided in a separate license agreement. 
 * 
 *---------------------------------------------------------------------
 */
#include "unmcopyright.h"
#include "xvforms.h"
#include "form_info.h"


/*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 >>>>
 >>>>         File Name:  form_init.c
 >>>>
 >>>>      Program Desc:  code to initialize fields
 >>>>                      in the structure found in form_info.h
 >>>>
 >>>>            Author:  automatically generated by conductor
 >>>>
 >>>> Date Last Updated:  Thu Mar 19 14:12:01 1992
 >>>>
 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/


_xvf_init_Master(formptr,forminfo)

xvf_form *formptr; 
Master *forminfo;
{
	int index;
	Line_Info line_info;
	char **database;

	xvf_clear_line_info(&line_info);
	database = formptr->db;

	/***** initializing 'Master' Form Information structure *****/

	forminfo->WarpImage = (Master_WarpImage *) 
			  malloc(sizeof(Master_WarpImage));


	index = 1;

	xvf_parse_startsubform_line(database[index], &line_info);
	forminfo->WarpImage_selected = line_info.selected;
	forminfo->WarpImage_index = 1;
	forminfo->WarpImage_sfb_index = 0;

	/*** initializing 'forminfo->WarpImage'
	      Subform Information structure ***/

	forminfo->WarpImage->workspace_index = 3;
	forminfo->WarpImage->view = false;
	forminfo->WarpImage->clear = false;
	forminfo->WarpImage->warp = false;
	forminfo->WarpImage->quit = false;
	forminfo->WarpImage->Options = (WarpImage_Options *) 
			  malloc(sizeof(WarpImage_Options));


	index = 14;

	xvf_parse_startpane_line(database[index], &line_info);
	forminfo->WarpImage->Options_selected = line_info.selected;
	forminfo->WarpImage->Options_index = 14;
	forminfo->WarpImage->Options_gb_index = 4;
	index++;


	/* initializing 'forminfo->WarpImage->Options'
	       Pane Information structure */

	xvf_parse_toggle_line(database[index], &line_info);
	forminfo->WarpImage->Options->operation_val = line_info.toggle_def;
	line_info.toggle_val = line_info.toggle_def;
	xvf_deparse_toggle_line(&line_info, database,index);
	forminfo->WarpImage->Options->operation_index = index;
forminfo->WarpImage->Options->operation_selected = false;
	index++;

	index = 19;
	index++;

	forminfo->WarpImage->Options->rb_zoom = false;
	forminfo->WarpImage->Options->rb_zoom_index = index;
	index++;

	forminfo->WarpImage->Options->pc_zoom = false;
	forminfo->WarpImage->Options->pc_zoom_index = index;
	index++;

	index++;

	xvf_parse_float_line(database[index], &line_info);
	forminfo->WarpImage->Options->src_zoom_factor = line_info.float_def;
	line_info.float_val = line_info.float_def;
	xvf_deparse_float_line(&line_info, database,index);
	forminfo->WarpImage->Options->src_zoom_factor_index = index;
forminfo->WarpImage->Options->src_zoom_factor_selected = false;
	index++;

	xvf_parse_float_line(database[index], &line_info);
	forminfo->WarpImage->Options->dest_zoom_factor = line_info.float_def;
	line_info.float_val = line_info.float_def;
	xvf_deparse_float_line(&line_info, database,index);
	forminfo->WarpImage->Options->dest_zoom_factor_index = index;
forminfo->WarpImage->Options->dest_zoom_factor_selected = false;
	index++;

	forminfo->WarpImage->Input = (WarpImage_Input *) 
			  malloc(sizeof(WarpImage_Input));


	index = 26;

	xvf_parse_startpane_line(database[index], &line_info);
	forminfo->WarpImage->Input_selected = line_info.selected;
	forminfo->WarpImage->Input_index = 26;
	forminfo->WarpImage->Input_gb_index = 5;
	index++;


	/* initializing 'forminfo->WarpImage->Input'
	       Pane Information structure */

	xvf_parse_input_line(database[index], &line_info);
	if (line_info.file_def != NULL) {
	   forminfo->WarpImage->Input->in_src_img = 
		xvf_strcpy(line_info.file_def);
	}
	else  forminfo->WarpImage->Input->in_src_img = NULL;

	xvf_deparse_input_line(&line_info, database, index);
	forminfo->WarpImage->Input->in_src_img_index = index;
forminfo->WarpImage->Input->in_src_img_selected = false;
	index++;

	xvf_parse_input_line(database[index], &line_info);
	if (line_info.file_def != NULL) {
	   forminfo->WarpImage->Input->in_dest_img = 
		xvf_strcpy(line_info.file_def);
	}
	else  forminfo->WarpImage->Input->in_dest_img = NULL;

	xvf_deparse_input_line(&line_info, database, index);
	forminfo->WarpImage->Input->in_dest_img_index = index;
forminfo->WarpImage->Input->in_dest_img_selected = false;
	index++;

	xvf_parse_output_line(database[index], &line_info);
	if (line_info.file_def != NULL) {
	   forminfo->WarpImage->Input->in_tp = 
		xvf_strcpy(line_info.file_def);
	}
	else  forminfo->WarpImage->Input->in_tp = NULL;

	xvf_deparse_output_line(&line_info, database,index);
	forminfo->WarpImage->Input->in_tp_index = index;
forminfo->WarpImage->Input->in_tp_selected = false;
	index++;

	forminfo->WarpImage->Output = (WarpImage_Output *) 
			  malloc(sizeof(WarpImage_Output));


	index = 31;

	xvf_parse_startpane_line(database[index], &line_info);
	forminfo->WarpImage->Output_selected = line_info.selected;
	forminfo->WarpImage->Output_index = 31;
	forminfo->WarpImage->Output_gb_index = 6;
	index++;


	/* initializing 'forminfo->WarpImage->Output'
	       Pane Information structure */

	xvf_parse_output_line(database[index], &line_info);
	if (line_info.file_def != NULL) {
	   forminfo->WarpImage->Output->out_tp = 
		xvf_strcpy(line_info.file_def);
	}
	else  forminfo->WarpImage->Output->out_tp = NULL;

	xvf_deparse_output_line(&line_info, database,index);
	forminfo->WarpImage->Output->out_tp_index = index;
forminfo->WarpImage->Output->out_tp_selected = false;
	index++;

	xvf_parse_output_line(database[index], &line_info);
	if (line_info.file_def != NULL) {
	   forminfo->WarpImage->Output->out_coeff = 
		xvf_strcpy(line_info.file_def);
	}
	else  forminfo->WarpImage->Output->out_coeff = NULL;

	xvf_deparse_output_line(&line_info, database,index);
	forminfo->WarpImage->Output->out_coeff_index = index;
forminfo->WarpImage->Output->out_coeff_selected = false;
	index++;

	if (!(xvf_create_subform(formptr->db, formptr, formptr->subform, true)))
	   return(false);
	_xvf_get_WarpImage(formptr, forminfo->WarpImage);
	return(true);

}

